// Generated by CoffeeScript 1.10.0
(function() {
  var React, ReactDOM, createMousetrap, invariant, shortcuts;

  React = require('react');

  ReactDOM = require('react-dom');

  invariant = require('invariant');

  createMousetrap = require('mousetrap');

  shortcuts = React.createFactory('shortcuts');

  module.exports = React.createClass({
    displayName: 'Shortcuts',
    _mousetrap: null,
    contextTypes: {
      shortcuts: React.PropTypes.object.isRequired
    },
    propTypes: {
      handler: React.PropTypes.func.isRequired,
      name: React.PropTypes.string.isRequired,
      tabIndex: React.PropTypes.number,
      className: React.PropTypes.string,
      eventType: React.PropTypes.string,
      stopPropagation: React.PropTypes.bool,
      preventDefault: React.PropTypes.bool,
      targetNode: React.PropTypes.object,
      ref: React.PropTypes.string,
      isGlobal: React.PropTypes.bool
    },
    getDefaultProps: function() {
      return {
        tabIndex: null,
        className: null,
        ref: null,
        eventType: null,
        stopPropagation: true,
        preventDefault: false,
        targetNode: null,
        isGlobal: false
      };
    },
    _bindShortcuts: function(shortcutsArr) {
      var element;
      element = this._getElementToBind();
      element.setAttribute('tabindex', this.props.tabIndex || -1);
      this._mousetrap = createMousetrap(element);
      this._monkeyPatchMousetrap();
      this._mousetrap.bind(shortcutsArr, this._handleShortcuts, this.props.eventType);
      if (this.props.isGlobal) {
        return element.addEventListener('shortcuts:global', this._customGlobalHandler);
      }
    },
    _customGlobalHandler: function(e) {
      var character, event, modifiers, ref;
      ref = e.detail, character = ref.character, modifiers = ref.modifiers, event = ref.event;
      if (e.target !== ReactDOM.findDOMNode(this) && e.target !== this.props.targetNode) {
        return this._mousetrap._handleKey(character, modifiers, event, true);
      }
    },
    _lastEvent: null,
    _monkeyPatchMousetrap: function() {
      var element, originalHandleKey;
      element = this._getElementToBind();
      originalHandleKey = this._mousetrap._handleKey;
      return this._mousetrap._handleKey = (function(_this) {
        return function(character, modifiers, event, customEvent) {
          if (!customEvent) {
            element.dispatchEvent(new CustomEvent('shortcuts:global', {
              detail: {
                character: character,
                modifiers: modifiers,
                event: event
              },
              bubbles: true,
              cancelable: true
            }));
            if (_this._lastEvent === event) {
              return null;
            }
          }
          _this._lastEvent = event;
          if (_this.props.preventDefault) {
            event.preventDefault();
          }
          if (_this.props.stopPropagation && !customEvent) {
            event.stopPropagation();
          }
          return originalHandleKey(character, modifiers, event);
        };
      })(this);
    },
    _getElementToBind: function() {
      var element;
      if (this.props.targetNode) {
        element = this.props.targetNode;
      } else {
        element = ReactDOM.findDOMNode(this);
      }
      invariant(element, 'TargetNode was not found.');
      return element;
    },
    _unbindShortcuts: function(shortcutsArr) {
      var element;
      element = this._getElementToBind();
      element.removeAttribute('tabindex');
      if (this._mousetrap) {
        this._mousetrap.unbind(shortcutsArr, this.props.eventType);
        return this._mousetrap.reset();
      }
    },
    _onUpdate: function() {
      var shortcutsArr;
      shortcutsArr = this.context.shortcuts.getShortcuts(this.props.name);
      this._unbindShortcuts(shortcutsArr);
      return this._bindShortcuts(shortcutsArr);
    },
    componentDidMount: function() {
      this._onUpdate();
      return this.context.shortcuts.addUpdateListener(this._onUpdate);
    },
    componentWillUnmount: function() {
      var element, shortcutsArr;
      shortcutsArr = this.context.shortcuts.getShortcuts(this.props.name);
      this._unbindShortcuts(shortcutsArr);
      this.context.shortcuts.removeUpdateListener(this._onUpdate);
      this._lastEvent = null;
      if (this.props.isGlobal) {
        element = this._getElementToBind();
        return element.removeEventListener('shortcuts:global', this._customGlobalHandler);
      }
    },
    _handleShortcuts: function(event, keyName) {
      var shortcutName;
      shortcutName = this.context.shortcuts.findShortcutName(keyName, this.props.name);
      return this.props.handler(shortcutName, event);
    },
    render: function() {
      var element;
      element = shortcuts;
      return element({
        tabIndex: this.props.tabIndex || -1,
        ref: this.props.ref,
        className: this.props.className
      }, this.props.children);
    }
  });

}).call(this);
